
/**
 * Модуль для  раздела "Настройки".
 */

var settings = (function () {
  return {
    supportCkeditorRss: null,
    /**
     * Инициализирует обработчики для кнопок и элементов раздела.
    */
    init: function() {      
      $('body').on('click', '.section-settings .settings-save', function(){
        settings.saveSettings();
      });
       $('body').on('click', '.section-settings .save-settings-system', function(){
        settings.saveSettingsKey();
      });

	  $('body').on('click',  '.section-settings .send-test-letter', function(){
        admin.ajaxRequest({
            mguniqueurl: "action/sendTestLetter",          
          },
          function(response) {
            admin.indication(response.status, response.msg);
            admin.refreshPanel();
          }
        );
		
      });	
	  
	  $('body').on('click',  '.section-settings .test-imap', function(){
        admin.ajaxRequest({
            mguniqueurl: "action/testImap",          
          },
          function(response) {
            admin.indication(response.status, response.msg);
            admin.refreshPanel();
          }
        );
		
      });	


    $('body').on('click',  '.section-settings .manual-moguta-sync', function(){
      admin.ajaxRequest({
          mguniqueurl: "action/manualMogutaSync",          
        },
        function(response) {
          admin.indication(response.status, response.msg);
        }
      );
  
    });	
	  
	  $('body').on('click',  '.section-settings .edit-settings-to-dkim', function(){
	    $('.section-settings input[name=dkimDomain]').val(''), 
        $('.section-settings input[name=dkimSelector]').val(''),
        settings.saveSettings();
	   /* admin.ajaxRequest({
            mguniqueurl: "action/testImap",          
          },
          function(response) {
            admin.indication(response.status, response.msg);
            admin.refreshPanel();
          }
        );*/
		
      });	
	  
	  

	  

	  
	   
      $('body').on('click', '.section-settings .tabs-settings a', function(){
        $('.tab-setting').hide();
        $('.section-settings .tabs-settings a').removeClass('active');
        $('#'+$(this).data('setting')).show();
        cookie('setting-active-tab', $(this).data('setting'));
        $(this).addClass('active');
        if($(this).data('setting')=='settings-templates'){
          settings.refreshCkeditor('');
        }
      });

      $('body').on('click', '#settings-templates .save-template', function(){
        settings.saveTemplate();
      });
	  
	  $('body').on('click', '#settings-templates .edit-template', function(){
        settings.editTemplate();
      });


      
      $('body').on('click', '#settings-smtp .save-smtp', function(){
        settings.saveSMTP($(this));
      });
      
      $('body').on('click', '#settings-smtp .delete-smtp', function(){
        settings.deleteSMTP($(this).data('id'));
      });
      
      $('body').on('click', '#settings-smtp .add-smtp', function(){
        settings.addSMTP();
      });
      
      $('body').on('click', '#settings-rss .save-rss', function(){
        
        settings.saveRSS($(this));
      });

      $('body').on('click', '#settings-rss .delete-rss', function(){
        settings.deleteRSS($(this).data('id'));
      });
      
      $('body').on('click', '#settings-rss .add-rss', function(){
        settings.addRSS();
      });
      
      $('body').on('click', '#settings-rss .edit-template-rss', function(){    
        try {
          if (CKEDITOR.instances['templateEditorRSS']) {
            CKEDITOR.instances['templateEditorRSS'].destroy();
          }
        } catch (e) {
        }    

        $('.rss-modal-template-send').data('id',$(this).parents('.box-param-rss').find('.save-rss').data('id'));

        var temp_text = $(this).parents('.box-param-rss').find('textarea[name=html_template]').val();

        $('#templateEditorRSS').ckeditor(function () {
          this.setData(temp_text);
        }); 

        $('.selectTemplateRss').hide();

        $('#modal-edit-template-rss').foundation('reveal','open');  
      });

      $('body').on('click', '#modal-edit-template-rss .view-select-template', function(){
         $('.selectTemplateRss').show();
      });
	  	

       $('body').on('click', '#modal-edit-template-rss .rss-modal-template-cancel', function(){
         $('#modal-edit-template-rss').foundation('reveal', 'close');
      });

       //сохранение шаблона rss шаблона
      $('body').on('click', '#modal-edit-template-rss .rss-modal-template-send', function(){        
        $('#settings-rss .save-rss[data-id='+$('.rss-modal-template-send').data('id')+']').parents('.box-param-rss').find('textarea[name=html_template]').val($('#templateEditorRSS').val());
        $('#modal-edit-template-rss').foundation('reveal', 'close');
      });

      $('body').on('change', '#modal-edit-template-rss select[name="template_id"]', function() {
        if(!confirm('Действующий шаблон будет заменен!')){
            return false;
        }
        var packed = {
          mguniqueurl:"action/getDataTemplate",
          id: $(this).val(),
         }
      
         admin.ajaxRequest(packed,
          function(response) {   
            settings.refreshCkeditor(response.data.html);
                  try {
                    if (CKEDITOR.instances['templateEditorRSS']) {
                      CKEDITOR.instances['templateEditorRSS'].destroy();
                    }
                  } catch (e) {
                  }    

                  $('#templateEditorRSS').ckeditor(function () {
                    this.setData(response.data.html);
                  }); 
          }
        );   
       
      });


      /*
       var packed = {
        mguniqueurl:"action/getDataTemplate",
        id: id,
       }
    
       admin.ajaxRequest(packed,
        function(response) {   
          $('.section-settings #settings-templates input[name=title]').val(response.data.title);
    
          settings.refreshCkeditor(response.data.html);
        }
      );   
      */
      
	 
	  
      $('body').on('change', '.section-settings input[name=enableDKMI]', function() {    
        if($('.section-settings input[name=enableDKMI]').val()!="true"){
          $('.enable-dkmi').hide();
        }else{
          $('.enable-dkmi').show();
        };
      });
	  
	  $('body').on('change', '.section-settings input[name=enableIMAP]', function() {    
        if($('.section-settings input[name=enableIMAP]').val()!="true"){
          $('.enable-imap').hide();
        }else{
          $('.enable-imap').show();
        };
      });

      $('body').on('change', '#settings-templates select[name="template_id"]', function() {
        if(!confirm('Все несохраненные изменения будут утеряны!')){
            return false;
        }

        $('.section-settings #settings-templates .save-template').hide();
        $('.section-settings #settings-templates .edit-template').hide();
        var tplId= $(this).val();
     
        if(tplId==0){         
           $('.section-settings #settings-templates .save-template').show();
        }else{
           $('.section-settings #settings-templates .edit-template').show();
        }
 
        settings.getDataTemplate(tplId);
      });


      $('body').on('click', '#settings-templates .delete-template', function(){
        
        var id = $('#settings-templates select[name="template_id"]').val();

        if (confirm('Удалить шаблон безвозвратно?')){
          admin.ajaxRequest({
            mguniqueurl: "action/deleteTemplate",
            id: id
          },
          function(response) {
            admin.indication(response.status, response.msg);
            admin.refreshPanel();
          }
        );
        }   
      });
      //Обработка  нажатия кнопки проверить версию
      $('.admin-center').on('click', '.clearLastUpdate', function(){         
        admin.ajaxRequest({
          mguniqueurl: "action/clearLastUpdate",         
        },
        function(response) {
          admin.indication(response.status, response.msg);
		      window.location = mgBaseDir+"/mg-admin/";
        }
        );
      });
      
      //Обработка  нажатия кнопки Приступить к обновлению
      $('.admin-center').on('click', '.update-now', function(){
       $(".loading-update-step-1").show();       
       $(".step-1-info").hide();   
       var buttonDownload = $(this);
       buttonDownload.hide();
        
       $('.start-update').hide();
       $(".step-process-info").show();
       $(".step-process-info").text('Пожалуйста, подождите! Идет загрузка обновления.');
       $('.step-eror-info').hide();
        var version = $("#lVer").text();
        
        admin.ajaxRequest({
          mguniqueurl: "action/preDownload",
          version: version
        },
        
        function(response) {
         // response.status = "success";
          $(".loading-update-step-1").hide();
          $(".step-process-info").hide();     
          $(".step-1-info").show();
          
          if('error'==response.status){
            admin.indication(response.status, response.msg);            
    
            $('.step-eror-info').show();
            $('.step-eror-info').text(response.msg);
            buttonDownload.show();  
            $('.start-update').show();
            
          } else{
              
            admin.indication(response.status, response.msg);
            
            $('.step-update-li-1').addClass('current');
            $('.step-update-li-1').addClass('completed');
            $('.step-update-li-2').removeClass('current');              
            $('.update-archive').show();           
            $("#lVer").html(version);
            $(".step-block .step1").hide();
            $(".step-block .step2").show();
            
          }  
        }
        );
          
      });
      
      //Обработка  нажатия кнопки Установить обновление
      $('.admin-center').on('click', '.update-archive', function(){
 
       var version = $("#lVer").text();
       $(".loading-update-step-2").show();
       $(".step-2-info").hide();
       var buttonArchive = $(this);
       buttonArchive.hide();  
       $(".step-process-info").show();       
       $(".step-process-info").text('Идет процесс применение изменений...');
    
        admin.ajaxRequest({
          mguniqueurl: "action/postDownload",
          version: version
        },
        function(response) {
          admin.indication(response.status, response.msg);   
          $(".loading-update-step-2").hide();
           if('error'==response.status){
            admin.indication(response.status, response.msg);            
            $('.error-update').remove();           
            $('.step-eror-info').html(response.msg+ '  <a href="'+admin.SITE+'/mg-admin'+'"> Начать процесс обновления с первого шага! </a>');     
            
          } else{              
            admin.indication(response.status, response.msg);            
            $('.step-update-li-2').addClass('current');
            // $('.step-update-li-2').addClass('completed');
            $('.step-update-li-3').removeClass('current');  
            $(".step-info").hide();     
            $(".step-process-info").text('Завешения процесса обновления, страница перезагрузится через 3 секунды ...');
            $(".loading-update-step-2").show();
            setTimeout(function() { window.location = mgBaseDir+"/mg-admin/"; }, 3000)

          }  
          
          
        }
        );
        return false;
      });
      // редактирование ключа для обновлений
      $('.admin-center').on('click', '.section-settings .edit-key', function(){
        $('.section-settings input[name="licenceKey"]').fadeIn();
        $('.section-settings .save-settings-system').fadeIn();        
        $(this).hide();       
      });
      
    },
    saveSettings: function() {
      var smtpSSL="true";
      if($('.section-settings input[name=smtpSSL]').val()!="true"){
        smtpSSL="false";
      };
	  var imapSSL="true";
      if($('.section-settings input[name=imapSSL]').val()!="true"){
        imapSSL="false";
      };
	  
	  
      
      var enableDKMI="true";
      if($('.section-settings input[name=enableDKMI]').val()!="true"){
        enableDKMI="false";
      };
	  var enableIMAP="true";
      if($('.section-settings input[name=enableIMAP]').val()!="true"){
        enableIMAP="false";
      };
	  var deleteLetterImap="true";
      if($('.section-settings input[name=deleteLetterImap]').val()!="true"){
        deleteLetterImap="false";
      };
           
		   
  
	  
      var packed = {
        mguniqueurl:"action/saveSettings",      
        options:{
          companyName: $('.section-settings input[name=companyName]').val(),
          adminEmail: $('.section-settings input[name=adminEmail]').val(),
          noReplyEmail: $('.section-settings input[name=noReplyEmail]').val(),
          smtpHost: $('.section-settings input[name=smtpHost]').val(),
          smtpPort: $('.section-settings input[name=smtpPort]').val(),
          smtpLogin: $('.section-settings input[name=smtpLogin]').val(),
          smtpPass: $('.section-settings input[name=smtpPass]').val(),
          dkimDomain: $('.section-settings input[name=dkimDomain]').val(),
          dkimPrivate: $('.section-settings input[name=dkimPrivate]').val(),
          dkimSelector: $('.section-settings input[name=dkimSelector]').val(),
          dkimPass: $('.section-settings input[name=dkimPass]').val(),
          dkimEmail: $('.section-settings input[name=dkimEmail]').val(),		 
          smtpSSL: smtpSSL,
          enableDKMI: enableDKMI,
          countTaskPacket: $('.section-settings input[name=countTaskPacket]').val(),
          countClicks: $('.section-settings input[name=countClicks]').val(),
          imapSSL: imapSSL,
          imapHost: $('.section-settings input[name=imapHost]').val(),
          imapPort: $('.section-settings input[name=imapPort]').val(),
          imapLogin: $('.section-settings input[name=imapLogin]').val(),
          imapPass: $('.section-settings input[name=imapPass]').val(),
          nameFrom: $('.section-settings input[name=nameFrom]').val(),
          enableIMAP: enableIMAP,
          deleteLetterImap: deleteLetterImap,
          mg_host: $('.section-settings input[name=mg_host]').val(),
          mg_username: $('.section-settings input[name=mg_username]').val(),
          mg_password: $('.section-settings input[name=mg_password]').val(),
          mg_listname_default: $('.section-settings select[name=mg_listname_default]').val()
        },
		dkimSecretKey: $('.section-settings textarea[name=dkimSecretKey]').val(),
       }

       admin.ajaxRequest(packed,
        function(response) {       
          admin.indication(response.status, response.msg);
          admin.refreshPanel();
        }
      );
   
     
    },
    saveSettingsKey: function() {               
      var packed = {
        mguniqueurl:"action/saveSettings",      
        options:{
          licenceKey: $('.section-settings input[name=licenceKey]').val()          
        }
       }
       admin.ajaxRequest(packed,
        function(response) {       
          admin.indication(response.status, response.msg);
          admin.refreshPanel();
        }
      );
   
     
    },
    
    saveSMTP: function(smtp) {
     
   
      var packed = {
        mguniqueurl:"action/saveSMTP",       
        host: smtp.parents('.box-param-smtp').find('input[name=host]').val(),
        login: smtp.parents('.box-param-smtp').find('input[name=login]').val(),
        pass: smtp.parents('.box-param-smtp').find('input[name=pass]').val(),
        port: smtp.parents('.box-param-smtp').find('input[name=port]').val(),
        ssl: smtp.parents('.box-param-smtp').find('input[name=ssl]').val(),
        counter_use: smtp.parents('.box-param-smtp').find('input[name=counter_use]').val(),
        max_letter_to_day: smtp.parents('.box-param-smtp').find('input[name=max_letter_to_day]').val(),
        time_bound: smtp.parents('.box-param-smtp').find('input[name=time_bound]').val(),
        last_use_time: smtp.parents('.box-param-smtp').find('input[name=last_use_time]').val(),
       }
       
        if(smtp.data('id')){
          packed.id = smtp.data('id');
        }
        
      admin.ajaxRequest(packed,
        function(response) {
          admin.indication(response.status, response.msg);
         
          admin.refreshPanel();
        }
      );
   
     
    },

    saveRSS: function(rss) {
      rss.parents('.box-param-rss').find('.error-input').removeClass('error-input');
      if(rss.parents('.box-param-rss').find('input[name=rss_link]').val()==''){
        rss.parents('.box-param-rss').find('input[name=rss_link]').addClass('error-input');
        return false;
      }
      
      var packed = {
        mguniqueurl:"action/saveRSS",       
        rss_link: rss.parents('.box-param-rss').find('input[name=rss_link]').val(),
        active: rss.parents('.box-param-rss').find('input[name=active]').val(),
        html_template: rss.parents('.box-param-rss').find('textarea[name=html_template]').val(),
        list_id: rss.parents('.box-param-rss').find('select[name=listname_id] option:selected').val(),
        time_send: rss.parents('.box-param-rss').find('input[name=time_send]').val(),
        }
      
        if(rss.data('id')){
          packed.id = rss.data('id');
        }
      //  console.log(packed);
      admin.ajaxRequest(packed,
        function(response) {
          admin.indication(response.status, response.msg);
         
          admin.refreshPanel();
        }
      );
   
     
    },


   deleteRSS: function(id) {
      if (confirm('Удалить?')) {
        admin.ajaxRequest({
          mguniqueurl: "action/deleteRSS",
          id: id
        },
        function(response) {     
          admin.indication(response.status, response.msg);
            
          admin.refreshPanel();
        }
      );
      }
    },
    
    addRSS: function(id) {
    
        admin.ajaxRequest({
          mguniqueurl: "action/addRSS",   
        },
        function(response) {
          //alert(1);
          admin.indication(response.status, response.msg);
          admin.refreshPanel();
        }
      );
   
    },


   deleteSMTP: function(id) {
      if (confirm('Удалить?')) {
        admin.ajaxRequest({
          mguniqueurl: "action/deleteSMTP",
          id: id
        },
        function(response) {     
          admin.indication(response.status, response.msg);
            
          admin.refreshPanel();
        }
      );
      }
    },
    
    addSMTP: function(id) {
    
        admin.ajaxRequest({
          mguniqueurl: "action/addSMTP",   
        },
        function(response) {
          admin.indication(response.status, response.msg);
          admin.refreshPanel();
        }
      );
   
    },

    saveTemplate: function() {	
      var packed = {
        mguniqueurl:"action/saveTemplate",    
        title: $('.section-settings #settings-templates input[name=title]').val(),
        html: $('.section-settings #settings-templates textarea[name=html]').val(),
       }
	//console.log(packed);
	
       admin.ajaxRequest(packed,
        function(response) {       
          admin.indication(response.status, response.msg);
          admin.refreshPanel();
        }
      );
   
     
    },
	 openSystemTab: function() {
      $('.tabs-settings .settings-system').click();
    },
	 editTemplate: function() {	
      var packed = {
        mguniqueurl:"action/editTemplate",    
        title: $('.section-settings #settings-templates input[name=title]').val(),
        html: $('.section-settings #settings-templates textarea[name=html]').val(),
		template_id: $('.section-settings #settings-templates select[name=template_id]').val(),
       }
	  // console.log(packed);
       admin.ajaxRequest(packed,
        function(response) {       
          admin.indication(response.status, response.msg);
          admin.refreshPanel();
        }
      );
   
     
    },

	
	
    getDataTemplate: function(id) {
      if(id==0){
        $('.section-settings #settings-templates input[name=title]').val('');
        $('.section-settings #settings-templates textarea[name=html]').val('');
        return false;
      }
  
      var packed = {
        mguniqueurl:"action/getDataTemplate",
        id: id,
       }
    
       admin.ajaxRequest(packed,
        function(response) {   
          $('.section-settings #settings-templates input[name=title]').val(response.data.title);
    
          settings.refreshCkeditor(response.data.html);
        }
      );   
     
    },

      refreshCkeditor: function(content) {
          
      try {
       if (CKEDITOR.instances['templateEditor']) {
         CKEDITOR.instances['templateEditor'].destroy();
        }
      } catch (e) {
      }      

      $('.section-settings #settings-templates textarea[name=html]').ckeditor(function () {
        this.setData(content);
      });
        
     
    },
     /**
     * отложенное открытие таба, применяется при перезагрузке
     */
    calbackOpenTab: function() {
      $('.section-settings .tabs-settings a[data-setting='+cookie('setting-active-tab')+']').click();         
        $(".timepicker").timepicker({
        timeOnlyTitle: 'Выберите время',
        timeText: 'Время:',
        hourText: 'Часы',
        minuteText: 'Минуты',
        secondText: 'Секунды',
        millisecText: 'Миллисекунды',
        currentText: 'Сейчас',
        closeText: 'Применить',
      })
    },
  }
})();

settings.init();
