<!DOCTYPE html>
<html class="no-js" lang="">
<head>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <title>Moguta.Mailer</title>
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" >
    <link rel="stylesheet" href="<?php echo SITE ?>/mg-admin/design/js/vendor/Font-Awesome/css/font-awesome.min.css">
    <link rel="stylesheet" href="<?php echo SITE ?>/mg-admin/design/css/style.css">
    <link rel="stylesheet" href="<?php echo SITE ?>/mg-admin/design/css/timepicker.min.css" type="text/css" />
    <?php if (USER::isAuth() && '1' == USER::getThis()->role): ?>
    <?php MG::titlePage($lang['ADMIN_BAR']); ?>

    <script type="text/javascript" src="<?php echo SITE ?>/mg-core/script/jquery-1.10.2.min.js"></script>
    <script type="text/javascript" src="<?php echo SITE ?>/mg-core/script/jquery.form.js"></script>
    <script type="text/javascript" src="<?php echo SITE ?>/mg-core/script/admin/admin.js"></script>
    <script> 
        var lang = <?php echo json_encode($lang)?>;
        var mgBaseDir = "<?php echo SITE?>" ;
    </script>
</head>
<body>
<div class="wrapper">
    <header class="header">
        <div class="header-top clearfix">
            <!--<a href="#" class="logo fl-left">
                <img src="<?php echo SITE ?>/mg-admin/design/images/logo.png" alt="">
                <span class="label success radius">v. 1.0</span>
            </a>-->
             <div class="right-side fl-left">
                 <ul class="inline-list">
                    <li><a href="javascript:void(0);" class="temp-as-cron"><span class="title">Moguta.Mailer™ <?php echo VER?></span>
                  <br>
                <p>Сервис для управления e-mail рассылками</p>
                  </a>

                </li>                   
                </ul>
            </div>
			
            <div class="right-side fl-right">
                <ul class="inline-list">
                    <li class="system-button"><a href="javascript:void(0);" class="temp-as-cron"><i class="fa fa-cogs"></i> <span class="text">Собрать очередь писем</span></a></li>
                    <li class="system-button"><a href="javascript:void(0);" class="temp-as-cron-send"><i class="fa fa-fighter-jet"></i> <span class="text">Отправить 100 шт.</span></a></li>
                    <li><a href="<?php echo SITE ?>/enter?logout=1"><i class="fa fa-sign-out"></i> <span class="text">Выйти</span></a></li>
                </ul>
            </div>
        </div>
        <nav class="top-bar">
            <section class="top-bar-section clearfix">
                <span class="menu-toggle">
                    <i class="fa fa-bars"></i>
                    <span>Меню</span>
                </span>
                <ul class="left top-menu">
                    <li class="active">
                        <a id="history" href="javascript:void(0);"
                           class="head-menu-btn tool-tip-bottom"><i class="fa fa-history"></i> <span>Очередь</span></a>
                    </li>
                    <li><a id="letter" href="javascript:void(0);" class="head-menu-btn tool-tip-bottom"><i
                                class="fa fa-envelope"></i> <span>Письма</span></a></li>

                    <?php /*<li><a id="autoresponder" href="javascript:void(0);" class="head-menu-btn tool-tip-bottom"><i
                                class="fa fa-envelope-o"></i> <span>Цепочки писем</span></a></li> */ ?>
                    <?php /*<li><a id="rss" href="javascript:void(0);" class="head-menu-btn tool-tip-bottom"><i
                                class="fa fa-rss"></i> <span>RSS трансляция</span></a></li>		*/ ?>
                    <li><a id="listemail" href="javascript:void(0);" class="head-menu-btn tool-tip-bottom"><i
                                class="fa fa-list"></i> <span>Подписки</span></a></li>
                    <li class="active"><a id="emailbase" href="javascript:void(0);"
                                          class="head-menu-btn tool-tip-bottom"><i class="fa fa-database"></i> <span>Подписчики</span></a>
                    </li>
                    <li><a id="settings" href="javascript:void(0);" class="head-menu-btn tool-tip-bottom"><i
                                class="fa fa-link"></i> <span>Настройки</span></a></li>

                </ul>
            </section>
        </nav>
    </header>

    <div class="content">
         <div class="notice-block">           
            <div class="mailLoader" style=""></div>
            <?php if(!empty($fakeKey)){ ?>
                <div id ="fakeKey" class="message_information inform alert-txt-dns-red">
                    <?php echo($fakeKey);?>
                </div>
            <?php }?>
            <?php if($newVersion){ ?> 
                <div id ="newVersion" class="message_information inform alert-box info" style="text-align: center;cursor: pointer;">
                    Доступна новая версия системы - <?php echo $newVersion;?>
                </div>
            <?php } ?>
            <?php if($trialError){ ?>
                <div style="background-color:#fffce5;text-align:center;padding:5px;" onclick="javascript:void(0);" class="message_information inform">
                    <?php echo $trialError;?>          
                </div>
            <?php } ?>
            <?php if(MG::getSetting('notifInfo') && !$_COOKIE['timeinfo_closed']) { 
                echo MG::getSetting('notifInfo');
            } ?>
        </div>

        <div id="thisHostName" style="display:none"><?php echo SITE; ?></div>
        <div id="color-theme" style="display:none"><?php echo $data['themeColor']; ?></div>
        <div id="bg-theme" style="display:none"><?php echo $data['themeBackground']; ?></div>
        <div id="staticMenu" style="display:none"><?php echo $data['staticMenu']; ?></div>

        <div class="admin-center">
            <div class="data">
                <!-- Контент раздела -->
            </div>
        </div>
        <div class="admin-h-height"></div>

    </div>

    <?php else:?>
  </head>
   <body>
        <div class="wrapper login-page">
            <div class="login-form">                
              <form action="<?php echo SITE?>/enter" method="POST" class="login">
                <div class="login-header">Войти в <span>Moguta.Mailer</span></div>
                <div class="login-body">
                    <?php if ($data['error']) :?>
                        <div class="error link-fail text-center"><?php echo $data['error']?> </div>
                    <?php endif;?>
                    <ul class="login-list">
                        <li><input type="email" required name="email" placeholder="Email" class="login-input"></li>
                        <li><input type="password" name="pass" placeholder="Пароль" class="pass-input"></li>
                    </ul>
                    <input type="hidden" name="location" value="/mg-admin" />                   
                    <div class="enter-buttons clearfix">
                        <a href="<?php echo SITE ?>/forgotpass" class="forgot-link fl-left">Забыли пароль?</a>
                        <button type="submit" class="radius button success fl-right">Войти</button>
                    </div>
                </div>
              </form>
            </div>
        </div>
   </body>
  <?php endif; ?>


</div>

<script src="<?php echo SITE ?>/mg-admin/design/js/modernizr.js"></script>
<script src="<?php echo SITE ?>/mg-admin/design/js/vendor/jquery/dist/jquery.min.js"></script>
<script src="<?php echo SITE ?>/mg-admin/design/js/foundation.min.js"></script>
<script src="<?php echo SITE ?>/mg-admin/design/js/script.js"></script>

</body>
</html>


